#!/bin/sh
#                                       
# Start the PPTP server daemon
#                                                                               

LOCALIP=`grep "^localip" /usr/syno/etc/synovpn/pptp/pptpd.conf | cut -d' ' -f 2`
BCRELAY=`grep "^bcrelay" /usr/syno/etc/synovpn/pptp/pptpd.conf | cut -d' ' -f 2`
        
start() { 
	Run=`/bin/get_key_value /usr/syno/etc/synovpn/synovpn.conf runpptpd`
	if [ "yes" != "$Run" ]; then
		exit 0;
	fi
	        
	echo -n "Starting PPTP server: "
	for i in slhc.ko ppp_generic.ko ppp_async.ko arc4.ko ppp_mppe.ko \
		bsd_comp.ko zlib_deflate.ko ppp_deflate.ko x_tables.ko \
		ip_tables.ko iptable_filter.ko nf_conntrack.ko \
		nf_defrag_ipv4.ko nf_conntrack_ipv4.ko nf_nat.ko \
		iptable_nat.ko ipt_REDIRECT.ko xt_multiport.ko xt_tcpudp.ko \
		xt_state.ko ipt_MASQUERADE.ko
	do
		/sbin/insmod /lib/modules/$i
	done

	if [ -n "`pidof pptpd`" ]; then
	   echo "Already running"
	   return
	fi                                                                          
	/usr/local/synovpn/sbin/pptpd -c /usr/syno/etc/synovpn/pptp/pptpd.conf -o /usr/syno/etc/synovpn/pptp/options.pptpd -p /var/run/pptpd.pid
	echo 1 > /proc/sys/net/ipv4/ip_forward
        
        /sbin/iptables -t nat -A POSTROUTING -s ${LOCALIP}/24 -j MASQUERADE
	
	/usr/local/synovpn/scripts/radiusd.sh start
}                                                                               
stop() {
	echo -n "Shutting down PPTP server: "

	#disconnect clients
	GREP_KEY=${LOCALIP}:
	/bin/kill `ps w |/bin/grep -v grep |/bin/grep ${GREP_KEY} | awk '{print $1;}'` 2>/dev/null
	
        /sbin/iptables -t nat -D POSTROUTING -s ${LOCALIP}/24 -j MASQUERADE
	
	/bin/kill `cat /var/run/pptpd.pid` 2>/dev/null
	sleep 1
	if [ -n "`pidof pptpd`" ]; then
	    echo "Failed to stop pptpd"
	fi
	#echo 0 > /proc/sys/net/ipv4/ip_forward

	/sbin/rmmod ipt_MASQUERADE xt_state xt_tcpudp xt_multiport \
		ipt_REDIRECT iptable_nat nf_nat nf_conntrack_ipv4 \
		nf_defrag_ipv4 nf_conntrack iptable_filter ip_tables x_tables
	/sbin/rmmod ppp_deflate zlib_deflate bsd_comp ppp_mppe arc4 ppp_async \
		ppp_generic slhc

	/usr/local/synovpn/scripts/radiusd.sh stop
}                                                                              
                                                                               
case "$1" in
	start)
		start
	;;
	stop)
		stop
	;;
	restart|reload)
		stop
		start
	;;
	condrestart)
		if [ -r /opt/var/run/pptpd.pid ]; then
			stop
			start
		fi
	;;
	*)
	echo "Usage: $0 {start|stop|restart|condrestart}"
	exit 1
esac
exit $?
